/* server.c
 * (c)15.10.1998 by Marek Zelem
 */

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include "computer.h"
#include <mmm/net_lib.h>

int timeout_read( int fd, void *buf, int count, int secs )
{ fd_set fds;
  struct timeval tv;
	FD_ZERO(&fds);
	FD_SET(fd,&fds);
	tv.tv_sec=secs;
	tv.tv_usec=0;
	if( select(fd+1,&fds,NULL,NULL,&tv)>0 && FD_ISSET(fd,&fds) )
		return( read(fd,buf,count) );
	return(-1);
}


int server( int sock )
{ int s,i,r;
  char buf[1024];
	while(1)
	{	s=netnamed_accept(sock,NULL);
		if( s<0 )	continue;
		net_getln(s,buf,1024);
		if( buf[0]!=0 && buf[strlen(buf)-1]=='\n' )
			buf[strlen(buf)-1]=0;
		i=0; r=-1;
		while( moduls[i].func!=NULL )
		{	if( (r=moduls[i].func(s,buf))>0 )
				break;
			i++;
		}
		if( r<=0 )
			net_printf(s,"Lutujem, ale nerozumiem Vasmu prikazu!\n");
		net_close(s);
	}
}

int main( int argc, char *argv[] )
{ int a,sock;
  char *dir="/services/computer";
  char *socket=".socket";

	a=1;
	while( a<argc && argv[a][0]=='-' )
	{	if( argv[a][1]=='h' )
			goto Usage;
		else if( argv[a][1]=='d' && a+1<argc )
		{	a++;
			dir=argv[a];
		}
		else if( argv[a][1]=='s' && a+1<argc )
		{	a++;
			socket=argv[a];
		}
		else
			printf("%s: Invalid argument: %s\n",argv[0],argv[a]);
		a++;
	}
	if( a<argc )
Usage:	{	printf("usage: %s [-d <dir>] [-s <socket>]\n",argv[0]);
		return(0);
	}
	if( chdir(dir)<0 )
	{	printf("%s: Can't set CWD to %s\n",argv[0],dir);
		return(-1);
	}
	unlink(socket);
	if( (sock=netnamed_bind(socket))<0 )
	{	printf("%s: Can't bind to %s\n",argv[0],socket);
		return(-1);
	}
	signal(SIGALRM,net_sigvoid);
	signal(SIGCHLD,net_sigchildexit);
	signal(SIGPIPE,SIG_IGN);
	for(a=0;moduls[a].func!=NULL;a++)
	{	if( moduls[a].init!=NULL )
			moduls[a].init();
	}
	return( server(sock) );
}

